<?php
/**
 * Created by PhpStorm.
 * User: 97
 */
namespace app\admin\controller;

use app\BaseController;

use AlibabaCloud\SDK\Tingwu\V20230930\Tingwu;
use \Exception;
use AlibabaCloud\Tea\Exception\TeaError;
use AlibabaCloud\Tea\Utils\Utils;

use Darabonba\OpenApi\Models\Config;
use AlibabaCloud\SDK\Tingwu\V20230930\Models\CreateTaskRequest;
use AlibabaCloud\Tea\Utils\Utils\RuntimeOptions;

use think\facade\Env;

class Indextwo extends BaseController{

    public function index(){
//        echo 'index-admin';

//        $ceshi = getenv("NUMBER_OF_PROCESSORS");
//        $aaa = getenv("PROCESSOR_ARCHITECTURE");
//        $accessKeyId = getenv("ALIBABA_CLOUD_ACCESS_KEY_ID");
//        $accessKeySecret = getenv("ALIBABA_CLOUD_ACCESS_KEY_SECRET");

//        $accessKeyId = Env::get("AliyunTingwu.AccessKeyId");
//        $accessSecret = Env::get("AliyunTingwu.AccessKeySecret");
//        echo $accessKeyId;
//        echo $accessSecret;
//        die;

        $this->main(array_slice(array(), 1));
    }


    /**
     * 使用AK&SK初始化账号Client
     * @return Tingwu Client
     */
    public static function createClient(){
        // 工程代码泄露可能会导致 AccessKey 泄露，并威胁账号下所有资源的安全性。以下代码示例仅供参考。
        // 建议使用更安全的 STS 方式，更多鉴权访问方式请参见：https://help.aliyun.com/document_detail/311677.html。
        $config = new Config([
            // 必填，请确保代码运行环境设置了环境变量 ALIBABA_CLOUD_ACCESS_KEY_ID。
            "accessKeyId" => Env::get("AliyunTingwu.AccessKeyId"),
            // 必填，请确保代码运行环境设置了环境变量 ALIBABA_CLOUD_ACCESS_KEY_SECRET。
            "accessKeySecret" => Env::get("AliyunTingwu.AccessKeySecret")
        ]);
        // Endpoint 请参考 https://api.aliyun.com/product/tingwu
        $config->endpoint = "tingwu.cn-beijing.aliyuncs.com";
        return new Tingwu($config);
    }

    /**
     * @param string[] $args
     * @return void
     */
    public static function main($args){
        $client = self::createClient();

        //  --- 之前模拟的数据
        //设置数据项  - -  第五层
        $contents = array();
        $contents['Name'] = "test";
        $contents['Prompt'] = "对话中客户表达的完整内容输出出来，并且请帮我将下面的对话进行总结，分析对话中客户是否有下单意愿以及商品是否感兴趣:\n {Transcription}";
        $contents['Model'] = "tingwu-turbo";
        $contents['TransType'] = "chat";

        //设置数据项  - -  第四层
        $customPrompt = array();
        $customPrompt['Contents'] = $contents;

        //设置数据项  - -  第三层
        $parameters = array();
        $parameters['CustomPromptEnabled'] = 'True';
        $parameters['CustomPrompt'] = $customPrompt;

        $inputone = array();
        $inputone['SourceLanguage'] = 'cn';
        $inputone['TaskKey'] = 'task'.'123123'.time();
        $inputone['FileUrl'] = 'https://crmapi.kedingdang.com/Intentionclient/getHuijieCallidRecordingFile?callid=9903ca31-b0c5-4d9b-aad1-cd6f97f87c43';

        //设置数据项  - -  第二层
        $body = array();
        $body['AppKey'] = 'jB3lTWgWwCCmO12g';
        $body['Input'] = $inputone;
        $body['Parameters'] = $parameters;

        //设置数据项  - -  第一层
        $data = array();
        $data['type'] = 'offline';
        $data['body'] = $body;

        $createTaskRequest = new CreateTaskRequest([
            "type" => "offline",
            "body" => $body
        ]);
        $headers = [];
        try {
            // 复制代码运行请自行打印 API 的返回值
            $client->createTaskWithOptions($createTaskRequest, $headers, new RuntimeOptions([]));
        }
        catch (Exception $error) {
            if (!($error instanceof TeaError)) {
                $error = new TeaError([], $error->getMessage(), $error->getCode(), $error);
            }
            // 此处仅做打印展示，请谨慎对待异常处理，在工程项目中切勿直接忽略异常。
            // 错误 message
            var_dump($error->message);
            // 诊断地址
            if($error->data){
                var_dump($error->data["Recommend"]);
            }
            Utils::assertAsString($error->message);
        }
    }


//  --- 之前模拟的数据
//            die;
//            //这里开始创建听悟的任务
//
//            //设置数据项  - -  第五层
//            $contents = array();
//            $contents['Name'] = "test";
//            $contents['Prompt'] = "对话中客户表达的完整内容输出出来，并且请帮我将下面的对话进行总结，分析对话中客户是否有下单意愿以及商品是否感兴趣:\n {Transcription}";
//            $contents['Model'] = "tingwu-turbo";
//            $contents['TransType'] = "chat";
//
//            //设置数据项  - -  第四层
//            $customPrompt = array();
//            $customPrompt['Contents'] = $contents;
//
//            //设置数据项  - -  第三层
//            $parameters = array();
//            $parameters['CustomPromptEnabled'] = 'True';
//            $parameters['CustomPrompt'] = $customPrompt;
//
//            $inputone = array();
//            $inputone['SourceLanguage'] = 'cn';
//            $inputone['TaskKey'] = 'task'.'123123'.time();
//            $inputone['FileUrl'] = 'https://crmapi.kedingdang.com/Intentionclient/getHuijieCallidRecordingFile?callid=9903ca31-b0c5-4d9b-aad1-cd6f97f87c43';
//
//            //设置数据项  - -  第二层
//            $body = array();
//            $body['AppKey'] = 'jB3lTWgWwCCmO12g';
//            $body['Input'] = $inputone;
//            $body['Parameters'] = $parameters;
//
//            //设置数据项  - -  第一层
//            $data = array();
//            $data['type'] = 'offline';
//            $data['body'] = $body;
//            //将数据转换为JSON格式
//            $data_string = json_encode($data);
//            //设置请求URL
//            $url = '/openapi/tingwu/v2/tasks';
//            //初始化curl请求
//            $curl = curl_init();
//            //设置curl选项
//            curl_setopt($curl, CURLOPT_URL, $url);
//            curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "PUT");
//            curl_setopt($curl, CURLOPT_POSTFIELDS, $data_string);
//            curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
//            curl_setopt($curl, CURLOPT_HTTPHEADER, array(
//                    'Content-Type: application/json',
//                    'Content-Length: ' . strlen($data_string))
//            );
//            //执行curl请求
//            $response = curl_exec($curl);
//            //关闭curl请求
//            curl_close($curl);
//            //输出响应信息
//            echo $response;
}
